diff --git a/src/main/java/net/minecraft/core/world/type/WorldType.java b/src/main/java/net/minecraft/core/world/type/WorldType.java
index 34013e664..6f3add051 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -13,6 +13,8 @@ import net.minecraft.core.world.weather.Weathers;
 import net.minecraft.core.world.wind.WindProvider;
 import net.minecraft.core.world.wind.WindProviderGeneric;
 
+import java.util.Random;
+
 public abstract class WorldType {
     private final String languageKey;
     private final Weather defaultWeather;
@@ -138,6 +140,7 @@ public abstract class WorldType {
         int x = 0;
         int y = 0;
         int z = 0;
+        Random random = new Random(world.getRandomSeed());
         int attemptsRemaining = 10000;
         spawnLoop:  while (true) {
             if (attemptsRemaining <= 0) {
@@ -146,8 +149,8 @@ public abstract class WorldType {
                 y = world.getHeightValue(x, z);
                 break spawnLoop;
             }
-            x += world.rand.nextInt(64) - world.rand.nextInt(64);
-            z += world.rand.nextInt(64) - world.rand.nextInt(64);
+            x += random.nextInt(64) - random.nextInt(64);
+            z += random.nextInt(64) - random.nextInt(64);
             for (y = getMaxY(); y >= getMinY(); y--) {
                 if (world.getBlockId(x, y + 1, z) == 0 && isValidSpawn(world, x, y, z)) {
                     break spawnLoop;
diff --git a/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
index e04ce0c60..99834d2de 100644
--- a/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
+++ b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldIndev.java
@@ -11,6 +11,8 @@ import net.minecraft.core.world.generate.chunk.indev.IndevWorldTheme;
 import net.minecraft.core.world.generate.chunk.indev.IndevWorldType;
 import net.minecraft.core.world.generate.chunk.indev.LevelGenerator;
 
+import java.util.Random;
+
 public class WorldTypeOverworldIndev
         extends WorldTypeOverworld {
     public WorldTypeOverworldIndev(Properties properties) {
@@ -27,10 +29,11 @@ public class WorldTypeOverworldIndev
         int x = 0;
         int y = 0;
         int z = 0;
+        Random random = new Random(world.getRandomSeed());
         spawnLoop:
         while (true) {
-            x = world.rand.nextInt(256);
-            z = world.rand.nextInt(256);
+            x = random.nextInt(256);
+            z = random.nextInt(256);
             for (y = getMaxY(); y >= getMinY(); y--) {
                 if (world.getBlockId(x, y + 1, z) == 0 && isValidSpawn(world, x, y, z)) {
                     break spawnLoop;
diff --git a/src/main/java/net/minecraft/server/MinecraftServer.java b/src/main/java/net/minecraft/server/MinecraftServer.java
index 9ec06012b..7a314abed 100644
--- a/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -20,6 +20,36 @@ import net.minecraft.core.net.IUpdatePlayerListBox;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.PropertyManager;
 import net.minecraft.core.net.ServerCommandEntry;
+import net.minecraft.core.net.command.CommandManager;
+import net.minecraft.core.net.command.commands.CommandAchievement;
+import net.minecraft.core.net.command.commands.CommandBiome;
+import net.minecraft.core.net.command.commands.CommandChunk;
+import net.minecraft.core.net.command.commands.CommandClear;
+import net.minecraft.core.net.command.commands.CommandClone;
+import net.minecraft.core.net.command.commands.CommandDamage;
+import net.minecraft.core.net.command.commands.CommandFill;
+import net.minecraft.core.net.command.commands.CommandGameMode;
+import net.minecraft.core.net.command.commands.CommandGameRule;
+import net.minecraft.core.net.command.commands.CommandGive;
+import net.minecraft.core.net.command.commands.CommandHeal;
+import net.minecraft.core.net.command.commands.CommandHelp;
+import net.minecraft.core.net.command.commands.CommandKill;
+import net.minecraft.core.net.command.commands.CommandMessage;
+import net.minecraft.core.net.command.commands.CommandMobSpawning;
+import net.minecraft.core.net.command.commands.CommandPlace;
+import net.minecraft.core.net.command.commands.CommandPlaySound;
+import net.minecraft.core.net.command.commands.CommandSay;
+import net.minecraft.core.net.command.commands.CommandSeed;
+import net.minecraft.core.net.command.commands.CommandSetBlock;
+import net.minecraft.core.net.command.commands.CommandSetSpawn;
+import net.minecraft.core.net.command.commands.CommandSpawn;
+import net.minecraft.core.net.command.commands.CommandSpawnParticle;
+import net.minecraft.core.net.command.commands.CommandSummon;
+import net.minecraft.core.net.command.commands.CommandTeleport;
+import net.minecraft.core.net.command.commands.CommandTellRaw;
+import net.minecraft.core.net.command.commands.CommandTestFor;
+import net.minecraft.core.net.command.commands.CommandTime;
+import net.minecraft.core.net.command.commands.CommandWeather;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.server.entity.player.PlayerServer;
 import net.minecraft.server.net.command.ConsoleCommandSource;
@@ -46,11 +76,27 @@ import net.minecraft.core.world.save.SaveHandlerServer;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypes;
-import net.minecraft.server.entity.EntityTracker;
+import net.minecraft.server.entity.EntityTrackerImpl;
 import net.minecraft.server.entity.ServerSkinVariantList;
 import net.minecraft.server.gui.ServerGui;
 import net.minecraft.server.net.NetworkListenThread;
 import net.minecraft.server.net.PlayerList;
+import net.minecraft.server.net.command.commands.CommandBan;
+import net.minecraft.server.net.command.commands.CommandColor;
+import net.minecraft.server.net.command.commands.CommandDeop;
+import net.minecraft.server.net.command.commands.CommandDifficulty;
+import net.minecraft.server.net.command.commands.CommandEmotes;
+import net.minecraft.server.net.command.commands.CommandKick;
+import net.minecraft.server.net.command.commands.CommandList;
+import net.minecraft.server.net.command.commands.CommandMe;
+import net.minecraft.server.net.command.commands.CommandNickname;
+import net.minecraft.server.net.command.commands.CommandOp;
+import net.minecraft.server.net.command.commands.CommandSave;
+import net.minecraft.server.net.command.commands.CommandScore;
+import net.minecraft.server.net.command.commands.CommandStop;
+import net.minecraft.server.net.command.commands.CommandUnban;
+import net.minecraft.server.net.command.commands.CommandWhitelist;
+import net.minecraft.server.net.command.commands.CommandWhoIs;
 import net.minecraft.server.world.ConvertProgressUpdater;
 import net.minecraft.server.world.WorldManager;
 import net.minecraft.server.world.WorldServer;
@@ -92,7 +138,7 @@ public class MinecraftServer
     public int percentDone;
     private final List<IUpdatePlayerListBox> playerListBoxes;
     private final List<ServerCommandEntry> commands;
-    public Map<Integer, EntityTracker> entityTrackerMap;
+    public Map<Integer, EntityTrackerImpl> entityTrackerMap;
     public boolean onlineMode;
     public boolean pvpOn;
     public boolean allowFlight;
@@ -174,6 +220,7 @@ public class MinecraftServer
         EntityDispatcher.init();
         TileEntityDispatcher.init();
         CommandHelper.init();
+        initCommands();
 
         LOGGER.info("Loading properties");
         propertyManager = new PropertyManager(new File("server.properties"));
@@ -308,9 +355,9 @@ public class MinecraftServer
             LOGGER.warn("To change this, set \"online-mode\" to \"true\" in the server.properties file.");
         }
         playerList = new PlayerList(this);
-        for (Integer id : Dimension.getDimensionList().keySet())
+        for (Map.Entry<Integer, Dimension> entry : Dimension.getDimensionList().entrySet())
         {
-            entityTrackerMap.put(id, new EntityTracker(this, id));
+            entityTrackerMap.put(entry.getKey(), new EntityTrackerImpl(this, entry.getValue()));
         }
         long time = System.nanoTime();
         String lName = propertyManager.getStringProperty("level-name", "world");
@@ -342,6 +389,55 @@ public class MinecraftServer
         return true;
     }
 
+    public void initCommands() {
+        CommandManager.registerCommand(new CommandAchievement());
+        CommandManager.registerCommand(new CommandClear());
+        CommandManager.registerCommand(new CommandKill());
+        CommandManager.registerCommand(new CommandSeed());
+        CommandManager.registerCommand(new CommandSetBlock());
+        CommandManager.registerCommand(new CommandSummon());
+        CommandManager.registerCommand(new CommandTeleport());
+        CommandManager.registerCommand(new CommandMessage());
+        CommandManager.registerCommand(new CommandSetSpawn());
+        CommandManager.registerCommand(new CommandTime());
+        CommandManager.registerCommand(new CommandGameMode());
+        CommandManager.registerCommand(new CommandWeather());
+        CommandManager.registerCommand(new CommandSpawn());
+        CommandManager.registerCommand(new CommandPlace());
+        CommandManager.registerCommand(new CommandHelp());
+        CommandManager.registerCommand(new CommandChunk());
+        CommandManager.registerCommand(new CommandGive());
+        CommandManager.registerCommand(new CommandGameRule());
+        CommandManager.registerCommand(new CommandFill());
+        CommandManager.registerCommand(new CommandClone());
+        CommandManager.registerCommand(new CommandBiome());
+        CommandManager.registerCommand(new CommandSay());
+        CommandManager.registerCommand(new CommandTellRaw());
+        CommandManager.registerCommand(new CommandTestFor());
+        CommandManager.registerCommand(new CommandDamage());
+        CommandManager.registerCommand(new CommandHeal());
+        CommandManager.registerCommand(new CommandMobSpawning());
+        CommandManager.registerCommand(new CommandPlaySound());
+        CommandManager.registerCommand(new CommandSpawnParticle());
+
+        CommandManager.registerServerCommand(new CommandStop());
+        CommandManager.registerServerCommand(new CommandOp());
+        CommandManager.registerServerCommand(new CommandDeop());
+        CommandManager.registerServerCommand(new CommandList());
+        CommandManager.registerServerCommand(new CommandDifficulty());
+        CommandManager.registerServerCommand(new CommandColor());
+        CommandManager.registerServerCommand(new CommandNickname());
+        CommandManager.registerServerCommand(new CommandWhoIs());
+        CommandManager.registerServerCommand(new CommandScore());
+        CommandManager.registerServerCommand(new CommandMe());
+        CommandManager.registerServerCommand(new CommandEmotes());
+        CommandManager.registerServerCommand(new CommandBan());
+        CommandManager.registerServerCommand(new CommandUnban());
+        CommandManager.registerServerCommand(new CommandKick());
+        CommandManager.registerServerCommand(new CommandWhitelist());
+        CommandManager.registerServerCommand(new CommandSave());
+    }
+
     private void convertWorld(ISaveFormat saveFormat, String worldDirName)
     {
         int worldSaveVersion = 0;
@@ -679,7 +775,7 @@ public class MinecraftServer
 
         networkServer.handleNetworkListenThread();
         playerList.onTick();
-        for (EntityTracker tracker : entityTrackerMap.values())
+        for (EntityTrackerImpl tracker : entityTrackerMap.values())
         {
             tracker.tick();
         }
@@ -780,7 +876,7 @@ public class MinecraftServer
         return dimensionWorlds.get(dimId);
     }
 
-    public EntityTracker getEntityTracker(int dimId)
+    public EntityTrackerImpl getEntityTracker(int dimId)
     {
         return entityTrackerMap.get(dimId);
     }
diff --git a/src/main/java/net/minecraft/server/entity/EntityTrackerEntry.java b/src/main/java/net/minecraft/server/entity/EntityTrackerEntryImpl.java
similarity index 76%
rename from src/main/java/net/minecraft/server/entity/EntityTrackerEntry.java
rename to src/main/java/net/minecraft/server/entity/EntityTrackerEntryImpl.java
index e2ceb9bb4..476ad3ab7 100644
--- a/src/main/java/net/minecraft/server/entity/EntityTrackerEntry.java
+++ b/src/main/java/net/minecraft/server/entity/EntityTrackerEntryImpl.java
@@ -4,6 +4,7 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.net.entity.EntityTrackerEntry;
 import net.minecraft.core.net.entity.NetEntityHandler;
 import net.minecraft.core.net.packet.MoveEntityPacket;
 import net.minecraft.core.net.packet.Packet;
@@ -23,7 +24,7 @@ import java.util.HashSet;
 import java.util.List;
 import java.util.Set;
 
-public class EntityTrackerEntry {
+public class EntityTrackerEntryImpl implements EntityTrackerEntry {
     public Entity trackedEntity;
     public int trackingDistance;
     public int packetDelay;
@@ -44,7 +45,7 @@ public class EntityTrackerEntry {
     private int ticksSinceLastTeleport;
     public boolean playerEntitiesUpdated;
     public Set<PlayerServer> trackedPlayers;
-    public EntityTrackerEntry(Entity entity, int trackingDistance, int packetDelay, boolean shouldSendMotionUpdates) {
+    public EntityTrackerEntryImpl(Entity entity, int trackingDistance, int packetDelay, boolean shouldSendMotionUpdates) {
         updateCounter = 0;
         ticksSinceLastTeleport = 0;
         firstUpdateDone = false;
@@ -63,8 +64,8 @@ public class EntityTrackerEntry {
 
     @Override
 	public boolean equals(Object obj) {
-        if (!(obj instanceof EntityTrackerEntry)) return false;
-        return ((EntityTrackerEntry)obj).trackedEntity.id == trackedEntity.id;
+        if (!(obj instanceof EntityTrackerEntryImpl)) return false;
+        return ((EntityTrackerEntryImpl)obj).trackedEntity.id == trackedEntity.id;
     }
 
     @Override
@@ -166,43 +167,45 @@ public class EntityTrackerEntry {
         sendPacketToTrackedPlayers(new RemoveEntityPacket(trackedEntity.id));
     }
 
-    public void removeFromTrackedPlayers(PlayerServer playerMP) {
-        trackedPlayers.remove(playerMP);
+    public void removeFromTrackedPlayers(Player player) {
+        trackedPlayers.remove(player);
     }
 
-    public void updatePlayerEntity(PlayerServer entityplayermp) {
-        if(entityplayermp == trackedEntity) {
+    public void updatePlayerEntity(Player player) {
+        assert player instanceof PlayerServer : "Player must be a instance of player server!";
+        PlayerServer playerServer = (PlayerServer) player;
+        if(playerServer == trackedEntity) {
             return;
         }
-        double dx = entityplayermp.x - (double)(encodedPosX / 32);
-        double dz = entityplayermp.z - (double)(encodedPosZ / 32);
+        double dx = playerServer.x - (double)(encodedPosX / 32);
+        double dz = playerServer.z - (double)(encodedPosZ / 32);
         if(dx >= (double)(-trackingDistance) && dx <= (double)trackingDistance && dz >= (double)(-trackingDistance) && dz <= (double)trackingDistance) {
-            if(!trackedPlayers.contains(entityplayermp)) {
-                trackedPlayers.add(entityplayermp);
-                entityplayermp.playerNetServerHandler.sendPacket(NetEntityHandler.getSpawnPacket(this));
+            if(!trackedPlayers.contains(playerServer)) {
+                trackedPlayers.add(playerServer);
+                playerServer.playerNetServerHandler.sendPacket(NetEntityHandler.getSpawnPacket(this));
                 if (trackedEntity.sendAdditionalData) {
-                    entityplayermp.playerNetServerHandler.sendPacket(new EntityTagDataPacket(trackedEntity));
+                    playerServer.playerNetServerHandler.sendPacket(new EntityTagDataPacket(trackedEntity));
                 }
                 if(shouldSendMotionUpdates) {
-                    entityplayermp.playerNetServerHandler.sendPacket(new SetEntityMotionPacket(trackedEntity.id, trackedEntity.xd, trackedEntity.yd, trackedEntity.zd));
+                    playerServer.playerNetServerHandler.sendPacket(new SetEntityMotionPacket(trackedEntity.id, trackedEntity.xd, trackedEntity.yd, trackedEntity.zd));
                 }
                 ItemStack[] aitemstack = trackedEntity.getInventory();
                 if(aitemstack != null) {
                     for(int i = 0; i < aitemstack.length; i++) {
-                        entityplayermp.playerNetServerHandler.sendPacket(new SetEquippedItemPacket(trackedEntity.id, i, aitemstack[i]));
+                        playerServer.playerNetServerHandler.sendPacket(new SetEquippedItemPacket(trackedEntity.id, i, aitemstack[i]));
                     }
                 }
-                if(trackedEntity instanceof Player) {
-                    Player entityplayer = (Player)trackedEntity;
-                    if(entityplayer.isPlayerSleeping())
+                if(trackedEntity instanceof PlayerServer) {
+                    PlayerServer trackedPlayerServer = (PlayerServer) trackedEntity;
+                    if(trackedPlayerServer.isPlayerSleeping())
                     {
-                        entityplayermp.playerNetServerHandler.sendPacket(new SleepPacket(trackedEntity, 0, MathHelper.floor(trackedEntity.x), MathHelper.floor(trackedEntity.y), MathHelper.floor(trackedEntity.z)));
+                        playerServer.playerNetServerHandler.sendPacket(new SleepPacket(trackedEntity, 0, MathHelper.floor(trackedEntity.x), MathHelper.floor(trackedEntity.y), MathHelper.floor(trackedEntity.z)));
                     }
                 }
             }
-        } else if(trackedPlayers.contains(entityplayermp)) {
-            trackedPlayers.remove(entityplayermp);
-            entityplayermp.playerNetServerHandler.sendPacket(new RemoveEntityPacket(trackedEntity.id));
+        } else if(trackedPlayers.contains(playerServer)) {
+            trackedPlayers.remove(playerServer);
+            playerServer.playerNetServerHandler.sendPacket(new RemoveEntityPacket(trackedEntity.id));
         }
     }
 
@@ -211,10 +214,18 @@ public class EntityTrackerEntry {
             updatePlayerEntity((PlayerServer) player);
         }
     }
-    public void removeTrackedPlayerSymmetric(PlayerServer playerMP) {
-        if(trackedPlayers.contains(playerMP)) {
-            trackedPlayers.remove(playerMP);
-            playerMP.playerNetServerHandler.sendPacket(new RemoveEntityPacket(trackedEntity.id));
+    public void removeTrackedPlayerSymmetric(Player player) {
+        if (player instanceof PlayerServer) {
+            PlayerServer playerServer = (PlayerServer) player;
+            if(trackedPlayers.contains(playerServer)) {
+                trackedPlayers.remove(playerServer);
+                playerServer.playerNetServerHandler.sendPacket(new RemoveEntityPacket(trackedEntity.id));
+            }
         }
     }
+
+    @Override
+    public Entity getTrackedEntity() {
+        return trackedEntity;
+    }
 }
diff --git a/src/main/java/net/minecraft/server/entity/EntityTrackerImpl.java b/src/main/java/net/minecraft/server/entity/EntityTrackerImpl.java
new file mode 100644
index 000000000..9be2e54b8
--- /dev/null
+++ b/src/main/java/net/minecraft/server/entity/EntityTrackerImpl.java
@@ -0,0 +1,146 @@
+package net.minecraft.server.entity;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.entity.EntityTracker;
+import net.minecraft.core.net.entity.EntityTrackerEntry;
+import net.minecraft.core.net.entity.ITrackedEntry;
+import net.minecraft.core.net.entity.NetEntityHandler;
+import net.minecraft.core.net.packet.Packet;
+import net.minecraft.core.util.collection.IntHashMap;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.server.MinecraftServer;
+import net.minecraft.server.entity.player.PlayerServer;
+
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.Set;
+
+public class EntityTrackerImpl implements EntityTracker {
+    public final Set<EntityTrackerEntryImpl> trackedEntitySet;
+    public final IntHashMap<EntityTrackerEntryImpl> trackedEntityHashTable;
+    public final MinecraftServer mcServer;
+    public final int maxTrackingDistanceThreshold;
+    public final Dimension dimension;
+
+    public EntityTrackerImpl(MinecraftServer minecraftserver, Dimension dimensions) {
+        trackedEntitySet = new HashSet<>();
+        trackedEntityHashTable = new IntHashMap<>();
+        mcServer = minecraftserver;
+        dimension = dimensions;
+        maxTrackingDistanceThreshold = minecraftserver.playerList.getMaxTrackingDistance();
+    }
+
+    @Override
+    public void trackEntity(Entity entity) {
+        ITrackedEntry<Entity> trackedConfig = NetEntityHandler.getTrackedEntry(entity);
+        if (trackedConfig != null){
+            EntityTrackerEntryImpl trackerEntry = trackEntity(entity, trackedConfig.getTrackingDistance(), trackedConfig.getPacketDelay(), trackedConfig.sendMotionUpdates());
+            trackedConfig.onEntityTracked(this, trackerEntry, entity);
+        }
+    }
+
+    @Override
+    public EntityTrackerEntryImpl trackEntity(Entity entity, int trackingDistance, int packetDelay, boolean shouldSendMotionUpdates)
+    {
+        if(trackingDistance > maxTrackingDistanceThreshold) {
+            trackingDistance = maxTrackingDistanceThreshold;
+        }
+        if(trackedEntityHashTable.containsValue(entity.id)) {
+            throw new IllegalStateException("Entity is already tracked!");
+        }
+        EntityTrackerEntryImpl trackerEntry = new EntityTrackerEntryImpl(entity, trackingDistance, packetDelay, shouldSendMotionUpdates);
+        trackedEntitySet.add(trackerEntry);
+        trackedEntityHashTable.put(entity.id, trackerEntry);
+        trackerEntry.updatePlayerEntities(mcServer.getDimensionWorld(dimension.id).players);
+        return trackerEntry;
+    }
+
+    @Override
+    public void untrackEntity(Entity entity)
+    {
+        if(entity instanceof PlayerServer)
+        {
+            PlayerServer playerServer = (PlayerServer)entity;
+            EntityTrackerEntryImpl entitytrackerentry1;
+            for(Iterator<EntityTrackerEntryImpl> iterator = trackedEntitySet.iterator(); iterator.hasNext(); entitytrackerentry1.removeFromTrackedPlayers(playerServer))
+            {
+                entitytrackerentry1 = iterator.next();
+            }
+
+        }
+        EntityTrackerEntryImpl entityTrackerEntry = trackedEntityHashTable.remove(entity.id);
+        if(entityTrackerEntry != null)
+        {
+            trackedEntitySet.remove(entityTrackerEntry);
+            entityTrackerEntry.sendDestroyEntityPacketToTrackedPlayers();
+        }
+    }
+
+    @Override
+    public void tick()
+    {
+        ArrayList<Entity> arraylist = new ArrayList<>();
+        for (EntityTrackerEntryImpl entityTrackerEntry : trackedEntitySet) {
+            entityTrackerEntry.tick(mcServer.getDimensionWorld(dimension.id).players);
+            if (entityTrackerEntry.playerEntitiesUpdated && (entityTrackerEntry.trackedEntity instanceof PlayerServer)) {
+                arraylist.add(entityTrackerEntry.trackedEntity);
+            }
+        }
+label0:
+        for(int i = 0; i < arraylist.size(); i++)
+        {
+            PlayerServer entityplayermp = (PlayerServer)arraylist.get(i);
+            Iterator<EntityTrackerEntryImpl> iterator1 = trackedEntitySet.iterator();
+            do
+            {
+                if(!iterator1.hasNext())
+                {
+                    continue label0;
+                }
+                EntityTrackerEntryImpl entitytrackerentry1 = iterator1.next();
+                if(entitytrackerentry1.trackedEntity != entityplayermp)
+                {
+                    entitytrackerentry1.updatePlayerEntity(entityplayermp);
+                }
+            } while(true);
+        }
+
+    }
+
+    @Override
+    public void sendPacketToTrackedPlayers(Entity entity, Packet packet)
+    {
+        EntityTrackerEntryImpl entityTrackerEntry = trackedEntityHashTable.get(entity.id);
+        if(entityTrackerEntry != null)
+        {
+            entityTrackerEntry.sendPacketToTrackedPlayers(packet);
+        }
+    }
+
+    @Override
+    public void sendPacketToTrackedPlayersAndTrackedEntity(Entity entity, Packet packet)
+    {
+        EntityTrackerEntryImpl entityTrackerEntry = trackedEntityHashTable.get(entity.id);
+        if(entityTrackerEntry != null)
+        {
+            entityTrackerEntry.sendPacketToTrackedPlayersAndTrackedEntity(packet);
+        }
+    }
+
+    @Override
+    public void removeTrackedPlayerSymmetric(Player player)
+    {
+        EntityTrackerEntryImpl entitytrackerentry;
+        for(Iterator<EntityTrackerEntryImpl> iterator = trackedEntitySet.iterator(); iterator.hasNext(); entitytrackerentry.removeTrackedPlayerSymmetric(player))
+        {
+            entitytrackerentry = iterator.next();
+        }
+    }
+
+    @Override
+    public Set<? extends EntityTrackerEntry> getTrackedEntries() {
+        return trackedEntitySet;
+    }
+}
diff --git a/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index eca2e4066..9d69846bb 100644
--- a/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -22,7 +22,7 @@ import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
-import net.minecraft.server.entity.EntityTracker;
+import net.minecraft.server.entity.EntityTrackerImpl;
 import net.minecraft.server.net.handler.PacketHandlerServer;
 import net.minecraft.core.net.packet.*;
 import net.minecraft.server.world.ServerPlayerController;
@@ -130,7 +130,7 @@ public class PlayerServer extends Player implements ContainerListener {
 	public void awardKillScore(Entity entity, int i)
     {
         super.awardKillScore(entity, i);
-        mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(username, nickname, uuid, score, chatColor, true, isOperator()));
+        mcServer.playerList.updatePlayerProfile(username, nickname, uuid, score, chatColor, true, isOperator());
     }
 
     public boolean isOperator()
@@ -356,7 +356,7 @@ public class PlayerServer extends Player implements ContainerListener {
         }
         if (score != lastScore)
         {
-            playerNetServerHandler.sendPacket(new UpdatePlayerProfilePacket(username, nickname, uuid, score, chatColor, true, isOperator()));
+            mcServer.playerList.updatePlayerProfile(username, nickname, uuid, score, chatColor, true, isOperator());
             lastScore = score;
         }
     }
@@ -410,7 +410,7 @@ public class PlayerServer extends Player implements ContainerListener {
     {
         if (!entity.removed)
         {
-            EntityTracker entitytracker = mcServer.getEntityTracker(dimension);
+            EntityTrackerImpl entitytracker = mcServer.getEntityTracker(dimension);
             if (entity instanceof EntityItem)
             {
                 entitytracker.sendPacketToTrackedPlayers(entity, new TakeItemEntityPacket(entity.id, id));
@@ -431,7 +431,7 @@ public class PlayerServer extends Player implements ContainerListener {
         {
             swingProgressInt = -1;
             isSwinging = true;
-            EntityTracker entitytracker = mcServer.getEntityTracker(dimension);
+            EntityTrackerImpl entitytracker = mcServer.getEntityTracker(dimension);
             entitytracker.sendPacketToTrackedPlayers(this, new AnimatePacket(this, 1));
         }
     }
@@ -446,7 +446,7 @@ public class PlayerServer extends Player implements ContainerListener {
         EnumSleepStatus status = super.sleepInBedAt(x, y, z);
         if (status == EnumSleepStatus.OK)
         {
-            EntityTracker entitytracker = mcServer.getEntityTracker(dimension);
+            EntityTrackerImpl entitytracker = mcServer.getEntityTracker(dimension);
             SleepPacket sleepPacket = new SleepPacket(this, 0, x, y, z);
             entitytracker.sendPacketToTrackedPlayers(this, sleepPacket);
             playerNetServerHandler.teleportAndRotate(this.x, this.y, this.z, yRot, xRot);
@@ -460,7 +460,7 @@ public class PlayerServer extends Player implements ContainerListener {
     {
         if (isPlayerSleeping())
         {
-            EntityTracker entitytracker = mcServer.getEntityTracker(dimension);
+            EntityTrackerImpl entitytracker = mcServer.getEntityTracker(dimension);
             entitytracker.sendPacketToTrackedPlayersAndTrackedEntity(this, new AnimatePacket(this, 3));
             super.wakeUpPlayer(flag, flag1);
         }
@@ -767,6 +767,10 @@ public class PlayerServer extends Player implements ContainerListener {
         playerNetServerHandler.teleportAndRotate(x, y, z, xr, yr);
     }
 
+    @Override
+    public boolean deferVehicleBehavior() {
+        return true;
+    }
 
     public PacketHandlerServer playerNetServerHandler;
     public MinecraftServer mcServer;
diff --git a/src/main/java/net/minecraft/server/net/PlayerList.java b/src/main/java/net/minecraft/server/net/PlayerList.java
index e90b83e9c..8956e75ba 100644
--- a/src/main/java/net/minecraft/server/net/PlayerList.java
+++ b/src/main/java/net/minecraft/server/net/PlayerList.java
@@ -11,6 +11,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.server.entity.player.PlayerServer;
 import net.minecraft.server.net.handler.PacketHandlerLogin;
 import net.minecraft.core.net.packet.*;
+import net.minecraft.server.player.PlayerListBox;
 import net.minecraft.server.player.PlayerManager;
 import net.minecraft.server.world.ServerPlayerController;
 import net.minecraft.core.util.helper.AES;
@@ -322,6 +323,11 @@ public class PlayerList
 
     }
 
+    public void updatePlayerProfile(String username, String nickname, UUID uuid, int score, byte chatColor, boolean isOnline, boolean isOperator) {
+        sendPacketToAllPlayers(new UpdatePlayerProfilePacket(username, nickname, uuid, score, chatColor, isOnline, isOperator));
+        PlayerListBox.updateList();
+    }
+
     public void sendEncryptedChatToAllPlayers(String message)
     {
         for (PlayerServer player : playerEntities) {
